/* autostats.c */
/* Ian Scott (ian@norcimo.com)*/
/* v2.1 (July 2001) */

/* You may freely copy, redistribute and modify this code for non-commercial purposes provided you acknowledge the original author and make freely available, under identical conditions and restrictions, all code thus produced  */

#include <stdio.h>
#include <string.h>
#include "stsallutil.h"
#include <math.h>

/* Produces statistics for each point in a series of files, saving the mean and error
The program operates on the stxtp#.txt files produced by autosts.c to save an averaged dI/dV/(IV) file complete with errors */

int main()
{
int specno,specmax,p,i,pmax;
float V,I,a,asqrt,pn[255];
FILE *infp, *outfp,*ofp;
char outname[255],inname[255],tempy[255];

/* Find how many spectra we're working with */
printf("Enter number of spectroscopy files:");
scanf("%d",&specmax);
if (specmax<1) /* Number of files entered is zero */
 	{
	printf("Have to have some specta!!\nExiting...\n\n");
	return 99;
	}
printf("Enter number of points:"); /* Find the number of points in each file */
scanf("%d",&pmax);
if (pmax<1) /* Number of points entered is zero */
	{
	printf("Have to have a point!!\nExiting...\n\n");
	return 99;
	}
printf("\nSaving to autostats.txt (individual files to statp#.txt)");
printf("\nProcessing...\n\n");
/* Open output file */
if ((ofp=fopen("autostats.txt","w"))==NULL)
	{
	printf("Couldn't open autostats.txt. Exiting..\n\n");
	return 99;
	}
for (p=1;p<=pmax;p++) /* Loop through the points */
        {
        strcpy(outname,"statp");
        strcat(outname,ims_itoa(p));
        strcat(outname,".txt");
        if ((outfp=fopen(outname,"w"))==NULL) /* Open output file for the current point */
        	{
        	printf("Couldn't open %s. Exiting..\n\n",outname);
        	fclose(ofp);
        	return 99;
        	}
        for (specno=1;specno<=specmax;specno++) /* Loop through the number of spectra */
        	{
        	strcpy(inname,"stxt");
        	strcat(inname,ims_itoa(specno));
        	strcat(inname,"p.txt");
        	if ((infp=fopen(inname,"r"))==NULL) /* Open the dI/dV/(IV) file */
        		{
        		printf("Couldn't open %s. Exiting..\n\n",inname);
        		fclose(outfp);
        		fclose(ofp);
        		return 99;
        		}
        	for (i=1;i<=p;i++)
        		fscanf(infp,"%f%f",&V,&I); /* Read points until the current point is read */
        	fprintf(outfp,"%f\n",I);
        	pn[specno]=I; /* Store the value of I /*
        	fclose(infp); /* Close the spectra file and continue to the next one */
        	}
        fclose(outfp); /* Close this point's output file */

        /*Calculate statistics*/

        a=0;
        asqrt=0;
        /*calulate average*/
        for (i=1;i<=specmax;i++)
        	{
        	a+=pn[i];

        	}

        a/=specmax;
        /* calculate standard deviation*/
        for (i=1;i<=specmax;i++)
        	{
        	pn[i]-=a;
        	pn[i]*=pn[i];
        	asqrt+=pn[i];
        	}
        asqrt/=(specmax-1);
        asqrt=sqrt(asqrt);

        /* Calculate standard deviation, standard error, etc */
        /* We'll write out V, ave, stddev, stderr, 2stderr */
                fprintf(ofp,"%f %f %f ",V,a,asqrt);
       I=sqrt((float)I);
       asqrt/=I;
        fprintf(ofp,"%f ",asqrt);
        asqrt*=2;
        fprintf(ofp,"%f\n",asqrt);
        /* We'll give the average +/- two standard errors */
        printf("Value of point %d is %f +/- %f",p,a,asqrt);
	/* Calculate percentage error (based on two standard errors) */
        if (a!=0)
	        a=asqrt/a*100;
        printf("  (%f%% error)\n",a);
        } /* Loop round onto the next point */
fclose(ofp); /*Close the main output file */
printf("\nFinished!\n\n");
return 1;
}
